#include <cstdio>
#include <cmath>
#include <vector>
#include <algorithm>
using namespace std;

struct pt { pt(double x, double y) : x(x), y(y) {} double x,y; };
double det(pt u, pt v) {
    return u.x * v.y - u.y * v.x;
}
double vcp(pt a,pt b,pt c) {
    return det(pt(b.x - a.x, b.y - a.y), pt(c.x - a.x, c.y - a.y));
}

int main(int argc, char **argv) {
    FILE *input = fopen(argv[1], "rt");
    FILE *output = fopen(argv[2], "rt");

    int testcases;
    fscanf(input," %d",&testcases);
 
    while (testcases--) {
        char ansboard[35][35];
        for (int y=0; y<30; y++)
            fscanf(output," %s",ansboard[y]);

        char board[35][35];
        for (int y=0; y<30; y++) {
            board[y][30] = 0;
            for (int x=0; x<30; x++) board[y][x] = '.';
        }

        int n;
        fscanf(input," %d",&n);
        while (n--) {
            vector<pt> pts;
            for (int i=0; i<3; i++) {
                double x,y;
                fscanf(input, " %lf %lf",&x,&y);
                pts.push_back(pt(x,y));
            }

            // sort the triangle into counter-clockwise order
            if (vcp(pts[0],pts[1],pts[2]) > 0) swap(pts[1], pts[2]);

            for (int yy=0; yy<30; yy++) {
                for (int xx=0; xx<30; xx++) {
                    double x = xx + 0.5;
                    double y = yy + 0.5;
                    if (((pts[0].x - pts[1].x) * (y - pts[0].y) - (pts[0].y - pts[1].y) * (x - pts[0].x) > 1e-4) &&
                        ((pts[1].x - pts[2].x) * (y - pts[1].y) - (pts[1].y - pts[2].y) * (x - pts[1].x) > 1e-4) &&
                        ((pts[2].x - pts[0].x) * (y - pts[2].y) - (pts[2].y - pts[0].y) * (x - pts[2].x) > 1e-4)) {
                        if (ansboard[yy][xx] != '*') goto badans;
                        board[yy][xx] = '*';
                    } else if (((pts[0].x - pts[1].x) * (y - pts[0].y) - (pts[0].y - pts[1].y) * (x - pts[0].x) > -1e-4) &&
                        ((pts[1].x - pts[2].x) * (y - pts[1].y) - (pts[1].y - pts[2].y) * (x - pts[1].x) > -1e-4) &&
                        ((pts[2].x - pts[0].x) * (y - pts[2].y) - (pts[2].y - pts[0].y) * (x - pts[2].x) > -1e-4)) {
                        if (board[yy][xx] != '*') board[yy][xx] = '#';
                    }
                }
            }
        }
        for (int y=0; y<30; y++) printf("%s\n",board[y]);
        for (int y=0; y<30; y++) {
            for (int x=0; x<30; x++) {
                if (board[y][x] == '.' && ansboard[y][x] != '.') goto badans;
            }
        }
    }
    printf("Yes\n");
    return 0;
badans:
    printf("Incorrect Output\n");
    return 0;
}