import java.io.*;
import java.util.*;

public class CSol {
    static double area(double[] a, double[] b, double[] c) {
	return
	    ((b[0] - a[0]) * (c[1] - a[1]) - 
	     (b[1] - a[1]) * (c[0] - a[0]))/2.0;
    }
    
    static void swap(double[] a, double[] b) {
	for (int i = 0; i < a.length && i < b.length; ++i) {
	    double t = a[i]; a[i] = b[i]; b[i] = t;
	}
    }

    public static void main(String[] args) throws Exception {
	BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	int n = Integer.parseInt(in.readLine());
	while (n-- > 0) {
	    char[][] screen = new char[35][35];
	    for (int pr = 0; pr < 30; ++pr) {
		for (int pc = 0; pc < 30; ++pc) screen[pr][pc] = '.';
	    }
	    
	    int ts = Integer.parseInt(in.readLine());
	    while (ts-- > 0) {
		StringTokenizer tok = new StringTokenizer(in.readLine());
		double[] a = { Double.parseDouble(tok.nextToken()), Double.parseDouble(tok.nextToken()) },
		    b = { Double.parseDouble(tok.nextToken()), Double.parseDouble(tok.nextToken()) },
			c = { Double.parseDouble(tok.nextToken()), Double.parseDouble(tok.nextToken()) };

			if (area(a, b, c) < 0) swap(b, c);
			
			for (int pr = 0; pr < 30; ++pr) {
			    for (int pc = 0; pc < 30; ++pc) {
				double[] p = { pc + 0.5, pr + 0.5 };
				if (area(a, b, p) >= 0 &&
				    area(b, c, p) >= 0 &&
				    area(c, a, p) >= 0) screen[pr][pc] = '*';
			    }
			}
	    }

	    for (int pr = 0; pr < 30; ++pr) {
		for (int pc = 0; pc < 30; ++pc) {
		    System.out.print(screen[pr][pc]);
		}
		
		System.out.println();
	    }
	    System.out.println();
	}
    }
}
