import java.io.*;
import java.util.*;

public class DSol {
    static int[] readObject(BufferedReader in) throws Exception {
	StringTokenizer tok = new StringTokenizer(in.readLine());
	return new int[] {
	    Integer.parseInt(tok.nextToken()),
	    Integer.parseInt(tok.nextToken()),
	    Integer.parseInt(tok.nextToken())
	};
    }

    static void mmAdd(Map map, int[] p) {
	SortedSet ss = (SortedSet) map.get(new Integer(p[2]));
	if (ss == null) {
	    ss = new TreeSet( new Comparator() {
		    public int compare(Object a, Object b) {
			int[] aa = (int[]) a;
			int[] bb = (int[]) b;
			for (int i = 0; i < aa.length; ++i) {
			    if (aa[i] < bb[i]) return -1;
			    else if (aa[i] > bb[i]) return +1;
			}
			return 0;
		    }
		}); map.put(new Integer(p[2]), ss);
	}
	ss.add(p);
    }

    static SortedMap floors;
    static SortedMap cache;
    
    static int search(int[] mel, int[] home) {
	int[] out = new int[] { Integer.MAX_VALUE, 0, 0, 0 };

	if (cache.containsKey(mel)) {
	    out = (int[]) cache.get(mel);
	    return out[0];
	}
	
	outer: for (Iterator it = floors.entrySet().iterator(); it.hasNext(); ) {
	    Map.Entry entry = (Map.Entry) it.next();
	    int y = ((Integer) entry.getKey()).intValue();
	    if (mel[2] <= y) continue;

	    SortedSet level = (SortedSet) entry.getValue();
	    for (Iterator fit = level.iterator(); fit.hasNext(); ) {
		int[] floor = (int[]) fit.next();
		if (mel[0] <= floor[0] || mel[0] >= floor[1]) continue;
		
		if (floor[2] == home[2] &&
		    floor[0] <= home[0] &&
		    floor[1] >= home[1]) {
		    int extra = 0, hdir = 0;
		    //System.out.println(mel[0] + " " + mel[2] + " -> " + home[0] + " " + home[1] + " " + home[2]);
		    if (home[0] >= mel[0]) { extra = home[0] - mel[0] + 1; hdir = +1; }
		    if (home[1] <= mel[0]) { extra = mel[0] - home[1] + 1; hdir = -1; }
		    out = new int[] { extra, hdir, Integer.MIN_VALUE, 0 };
		}

		{
		    int att = search(new int[] { floor[1], mel[1], floor[2] }, home);
		    if (att != Integer.MAX_VALUE)
			att += Math.abs(mel[2] - y) + Math.abs(mel[0] - floor[1]);
		    if (att < out[0]) out = new int[] { att, +1, floor[1], floor[2] };
		}
		{
		    int att = search(new int[] { floor[0], mel[1], floor[2] }, home);
		    if (att != Integer.MAX_VALUE)
			att += Math.abs(mel[2] - y) + Math.abs(mel[0] - floor[0]);
		    if (att < out[0]) out = new int[] { att, -1, floor[0], floor[2] };
		}

		break outer;
	    }
	}
	
	cache.put(mel, out);
	return out[0];
    }

    public static void main(String[] args) throws Exception {
	BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	int n = Integer.parseInt(in.readLine());
	while (n-- > 0) {
	    floors = new TreeMap(new Comparator() {
		    public int compare(Object a, Object b) {
			return -((Comparable) a).compareTo(b);
		    }
		});
	    cache = new TreeMap(new Comparator() {
		    public int compare(Object a, Object b) {
			int[] aa = (int[]) a, bb = (int[]) b;
			for (int i = 0; i < aa.length; ++i) {
			    if (aa[i] < bb[i]) return -1;
			    if (aa[i] > bb[i]) return +1;
			}
			return 0;
		    }
		});
	    
	    int[] mel = readObject(in), home = readObject(in);
	    int melWidth = mel[1] - mel[0];
	    home[0] -= melWidth;
	    mmAdd(floors, new int[] { home[0], home[1], home[2] });
	    while (true) {
		int[] obj = readObject(in);
		if (obj[0] == -1) break;
		obj[0] -= melWidth;
		mmAdd(floors, obj);
	    }
	    
	    for (Iterator it = floors.entrySet().iterator(); it.hasNext(); ) {
		Map.Entry entry = (Map.Entry) it.next();
		SortedSet ss = (SortedSet) entry.getValue();
		int[] last = null;
		for (Iterator it2 = ss.iterator(); it2.hasNext(); ) {
		    int[] curr = (int[]) it2.next();
		    if (last != null && last[1] > curr[0]) {
			last[1] = curr[1];
			it2.remove();
		    }
		    else last = curr;
		}
	    }

	    search(mel, home);

	    int[] key = { mel[0], mel[1], mel[2] };
	    while (true) {
		//System.out.print("Searching " + key[0] + "," + key[1] + "," + key[2]);
		int[] val = (int[]) cache.get(key);
		if (val == null) {
		    System.out.println(" !SNAFU!");
		    break;
		}
		//System.out.println(" got " + val[0] + "," + val[1] + "," + val[2] + "," + val[3]);
		if (val[0] == Integer.MAX_VALUE) {
		    System.out.println("GATOR BAIT");
		    break;
		}
		if (val[0] == 0) {
		    System.out.println();
		    break;
		}
		if (val[1] < 0) System.out.print("W");
		else if (val[1] > 0) System.out.print("E");
		else System.out.print("!");

		if (val[2] == Integer.MIN_VALUE) {
		    System.out.println();
		    break;
		}
		key[0] = val[2];
		key[2] = val[3];
	    }
	}
    }
};
